/*
 * Copyright (c) 2014 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution  and  use  in  source  and binary  forms,  with  or  without
 * modification, are permitted provided that the following conditions are met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice and this list of conditions.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice and  this list of  conditions in the  documentation and/or
 *      other materials provided with the distribution.
 *
 * THE SOFTWARE  IS PROVIDED "AS IS"  AND THE AUTHOR  DISCLAIMS ALL WARRANTIES
 * WITH  REGARD   TO  THIS  SOFTWARE  INCLUDING  ALL   IMPLIED  WARRANTIES  OF
 * MERCHANTABILITY AND  FITNESS.  IN NO EVENT  SHALL THE AUTHOR  BE LIABLE FOR
 * ANY  SPECIAL, DIRECT,  INDIRECT, OR  CONSEQUENTIAL DAMAGES  OR  ANY DAMAGES
 * WHATSOEVER  RESULTING FROM  LOSS OF  USE, DATA  OR PROFITS,  WHETHER  IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR  OTHER TORTIOUS ACTION, ARISING OUT OF OR
 * IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 *                                           Anthony Mallet on Fri May 23 2014
 */
#ifndef H_FLASH
#define H_FLASH

#include <stdint.h>
#include <libelf.h>

#define TK3_MAGIC	"tk3"

enum memk { FL_FLASH, FL_EEPROM };

int     open_tty(const char *input, unsigned int baud);
void	write_serial(int fd, const void *buf, size_t count);
ssize_t	read_serial(int fd, void *buf, size_t count, int timeout);

Elf *	elf_init(const char *input);
char *	elf_loadable_data(Elf *elf, size_t *size, enum memk kind);

uint16_t mkbl_crc16(char *buffer, size_t len);

int	mkbl_flash(const char *exe, const char *port, int baud,
                int init_p);
int	mkbl_params(const char *port, int baud, char **argv);

void	print_settings(const char *data);

#endif /* H_FLASH */
